diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/mac8-address.h ns-3.41/src/network/utils/mac8-address.h
--- ns-3.40/src/network/utils/mac8-address.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/mac8-address.h	2024-02-09 14:44:08.425794000 -0800
@@ -43,8 +43,7 @@
 class Mac8Address
 {
   public:
-    /** Constructor */
-    Mac8Address();
+    Mac8Address() = default;
     /**
      * Create Mac8Address object with address addr.
      *
@@ -132,7 +131,7 @@
 
   private:
     static uint8_t m_allocationIndex; //!< Address allocation index
-    uint8_t m_address;                //!< The address.
+    uint8_t m_address{255};           //!< The address.
 
     /**
      * Get the Mac8Address type.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/net-device-queue-interface.h ns-3.41/src/network/utils/net-device-queue-interface.h
--- ns-3.40/src/network/utils/net-device-queue-interface.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/net-device-queue-interface.h	2024-02-09 14:44:08.425794000 -0800
@@ -364,7 +364,7 @@
     NS_LOG_FUNCTION(this << queue << item);
     NS_ASSERT_MSG(m_device, "Aggregated NetDevice not set");
 
-    Simulator::ScheduleNow([=]() {
+    Simulator::ScheduleNow([=, this]() {
         // Inform BQL
         NotifyTransmittedBytes(item->GetSize());
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/packet-socket.cc ns-3.41/src/network/utils/packet-socket.cc
--- ns-3.40/src/network/utils/packet-socket.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/packet-socket.cc	2024-02-09 14:44:08.425794000 -0800
@@ -122,7 +122,7 @@
 PacketSocket::Bind6()
 {
     NS_LOG_FUNCTION(this);
-    return (Bind());
+    return Bind();
 }
 
 int
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/packet-socket-client.cc ns-3.41/src/network/utils/packet-socket-client.cc
--- ns-3.40/src/network/utils/packet-socket-client.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/packet-socket-client.cc	2024-02-09 14:44:08.425794000 -0800
@@ -183,7 +183,17 @@
 
     if ((m_sent < m_maxPackets) || (m_maxPackets == 0))
     {
-        m_sendEvent = Simulator::Schedule(m_interval, &PacketSocketClient::Send, this);
+        if (m_interval.IsZero())
+        {
+            NS_ABORT_MSG_IF(
+                m_maxPackets == 0,
+                "Generating infinite packets at the same time does not seem to be a good idea");
+            Send();
+        }
+        else
+        {
+            m_sendEvent = Simulator::Schedule(m_interval, &PacketSocketClient::Send, this);
+        }
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/packet-socket-client.h ns-3.41/src/network/utils/packet-socket-client.h
--- ns-3.40/src/network/utils/packet-socket-client.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/packet-socket-client.h	2024-02-09 14:44:08.425794000 -0800
@@ -91,6 +91,11 @@
 
     /**
      * \brief Send a packet
+     *
+     * Either <i>Interval</i> and <i>MaxPackets</i> may be zero, but not both.  If <i>Interval</i>
+     * is zero, the PacketSocketClient will send <i>MaxPackets</i> packets without any delay into
+     * the socket.  If <i>MaxPackets</i> is zero, then the PacketSocketClient will send every
+     * <i>Interval</i> until the application is stopped.
      */
     void Send();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/queue-size.cc ns-3.41/src/network/utils/queue-size.cc
--- ns-3.40/src/network/utils/queue-size.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/queue-size.cc	2024-02-09 14:44:08.429793800 -0800
@@ -1,21 +1,21 @@
-//
-// Copyright (c) 2018 Universita' degli Studi di Napoli Federico II
-//
-// This program is free software; you can redistribute it and/or modify
-// it under the terms of the GNU General Public License version 2 as
-// published by the Free Software Foundation;
-//
-// This program is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without even the implied warranty of
-// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.
-//
-// You should have received a copy of the GNU General Public License
-// along with this program; if not, write to the Free Software
-// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-//
-// Author: Stefano Avallone <stavallo@unina.it>
-//
+/*
+ * Copyright (c) 2018 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
 
 #include "queue-size.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/queue-size.h ns-3.41/src/network/utils/queue-size.h
--- ns-3.40/src/network/utils/queue-size.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/queue-size.h	2024-02-09 14:44:08.429793800 -0800
@@ -1,21 +1,21 @@
-//
-// Copyright (c) 2018 Universita' degli Studi di Napoli Federico II
-//
-// This program is free software; you can redistribute it and/or modify
-// it under the terms of the GNU General Public License version 2 as
-// published by the Free Software Foundation;
-//
-// This program is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without even the implied warranty of
-// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.
-//
-// You should have received a copy of the GNU General Public License
-// along with this program; if not, write to the Free Software
-// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-//
-// Author: Stefano Avallone <stavallo@unina.it>
-//
+/*
+ * Copyright (c) 2018 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
 
 #ifndef QUEUE_SIZE_H
 #define QUEUE_SIZE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/utils/sequence-number.h ns-3.41/src/network/utils/sequence-number.h
--- ns-3.40/src/network/utils/sequence-number.h	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/network/utils/sequence-number.h	2024-02-09 14:44:08.429793800 -0800
@@ -293,7 +293,7 @@
      */
     bool operator==(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
     {
-        return (m_value == other.m_value);
+        return m_value == other.m_value;
     }
 
     /**
@@ -303,7 +303,7 @@
      */
     bool operator!=(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
     {
-        return (m_value != other.m_value);
+        return m_value != other.m_value;
     }
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/nix-vector-routing/model/nix-vector-routing.cc ns-3.41/src/nix-vector-routing/model/nix-vector-routing.cc
--- ns-3.40/src/nix-vector-routing/model/nix-vector-routing.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/nix-vector-routing/model/nix-vector-routing.cc	2024-02-09 14:44:08.429793800 -0800
@@ -68,7 +68,7 @@
     {
         name = "Ipv6";
     }
-    static TypeId tid = TypeId(("ns3::" + name + "NixVectorRouting"))
+    static TypeId tid = TypeId("ns3::" + name + "NixVectorRouting")
                             .SetParent<T>()
                             .SetGroupName("NixVectorRouting")
                             .template AddConstructor<NixVectorRouting<T>>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/olsr/examples/olsr-hna.cc ns-3.41/src/olsr/examples/olsr-hna.cc
--- ns-3.40/src/olsr/examples/olsr-hna.cc	2023-09-27 13:30:37.858839800 -0700
+++ ns-3.41/src/olsr/examples/olsr-hna.cc	2024-02-09 14:44:08.433793800 -0800
@@ -49,7 +49,6 @@
 // ./ns3 run "olsr-hna --assocMethod=AddHostNetwork"
 //
 
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/olsr/model/olsr-routing-protocol.cc ns-3.41/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.40/src/olsr/model/olsr-routing-protocol.cc	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/olsr/model/olsr-routing-protocol.cc	2024-02-09 14:44:08.433793800 -0800
@@ -226,7 +226,7 @@
             .AddAttribute("Willingness",
                           "Willingness of a node to carry and forward traffic for other nodes.",
                           EnumValue(Willingness::DEFAULT),
-                          MakeEnumAccessor(&RoutingProtocol::m_willingness),
+                          MakeEnumAccessor<Willingness>(&RoutingProtocol::m_willingness),
                           MakeEnumChecker(Willingness::NEVER,
                                           "never",
                                           Willingness::LOW,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/openflow/CMakeLists.txt ns-3.41/src/openflow/CMakeLists.txt
--- ns-3.40/src/openflow/CMakeLists.txt	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/openflow/CMakeLists.txt	2024-02-09 14:44:08.433793800 -0800
@@ -14,6 +14,7 @@
   HEADER_NAME openflow.h
   LIBRARY_NAME openflow
   SEARCH_PATHS ${NS3_WITH_OPENFLOW}
+  OUTPUT_VARIABLE "NS3_OPENFLOW_REASON"
 )
 
 if((NOT
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/openflow/examples/openflow-switch.py ns-3.41/src/openflow/examples/openflow-switch.py
--- ns-3.40/src/openflow/examples/openflow-switch.py	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/openflow/examples/openflow-switch.py	2024-02-09 14:44:08.433793800 -0800
@@ -18,7 +18,14 @@
 #              Gabriel Ferreira <gabrielcarvfer@gmail.com>
 #
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 ns.LogComponentEnable("OpenFlowInterface", ns.LOG_LEVEL_ALL)
 ns.LogComponentEnable("OpenFlowSwitchNetDevice", ns.LOG_LEVEL_ALL)
@@ -60,7 +67,9 @@
 
 port = 9
 
-onoff = ns.OnOffHelper("ns3::UdpSocketFactory", ns.InetSocketAddress(ns.Ipv4Address("10.1.1.2"), port).ConvertTo())
+onoff = ns.OnOffHelper(
+    "ns3::UdpSocketFactory", ns.InetSocketAddress(ns.Ipv4Address("10.1.1.2"), port).ConvertTo()
+)
 onoff.SetConstantRate(ns.DataRate("500kb/s"))
 
 app = onoff.Install(terminals.Get(0))
@@ -68,12 +77,15 @@
 app.Start(ns.Seconds(1.0))
 app.Stop(ns.Seconds(10.0))
 
-sink = ns.PacketSinkHelper("ns3::UdpSocketFactory",
-                           ns.InetSocketAddress(ns.Ipv4Address.GetAny(), port).ConvertTo())
+sink = ns.PacketSinkHelper(
+    "ns3::UdpSocketFactory", ns.InetSocketAddress(ns.Ipv4Address.GetAny(), port).ConvertTo()
+)
 app = sink.Install(terminals.Get(1))
 app.Start(ns.Seconds(0.0))
 
-onoff.SetAttribute("Remote", ns.AddressValue(ns.InetSocketAddress(ns.Ipv4Address("10.1.1.1"), port).ConvertTo()))
+onoff.SetAttribute(
+    "Remote", ns.AddressValue(ns.InetSocketAddress(ns.Ipv4Address("10.1.1.1"), port).ConvertTo())
+)
 app = onoff.Install(terminals.Get(3))
 app.Start(ns.Seconds(1.1))
 app.Stop(ns.Seconds(10.0))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/point-to-point/helper/point-to-point-helper.cc ns-3.41/src/point-to-point/helper/point-to-point-helper.cc
--- ns-3.40/src/point-to-point/helper/point-to-point-helper.cc	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/point-to-point/helper/point-to-point-helper.cc	2024-02-09 14:44:08.453794000 -0800
@@ -197,7 +197,7 @@
     uint32_t deviceid = nd->GetIfIndex();
     std::ostringstream oss;
 
-    oss << "/NodeList/" << nd->GetNode()->GetId() << "/DeviceList/" << deviceid
+    oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
         << "/$ns3::PointToPointNetDevice/MacRx";
     Config::Connect(oss.str(),
                     MakeBoundCallback(&AsciiTraceHelper::DefaultReceiveSinkWithContext, stream));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/CMakeLists.txt ns-3.41/src/propagation/CMakeLists.txt
--- ns-3.40/src/propagation/CMakeLists.txt	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/propagation/CMakeLists.txt	2024-02-09 14:44:08.453794000 -0800
@@ -30,8 +30,7 @@
     model/propagation-loss-model.h
     model/three-gpp-propagation-loss-model.h
     model/three-gpp-v2v-propagation-loss-model.h
-  LIBRARIES_TO_LINK ${libnetwork}
-                    ${libmobility}
+  LIBRARIES_TO_LINK ${libmobility}
   TEST_SOURCES
     test/channel-condition-model-test-suite.cc
     test/itu-r-1411-los-test-suite.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/channel-condition-model.cc ns-3.41/src/propagation/model/channel-condition-model.cc
--- ns-3.40/src/propagation/model/channel-condition-model.cc	2023-09-27 13:30:37.862839700 -0700
+++ ns-3.41/src/propagation/model/channel-condition-model.cc	2024-02-09 14:44:08.453794000 -0800
@@ -102,43 +102,43 @@
 bool
 ChannelCondition::IsLos() const
 {
-    return (m_losCondition == ChannelCondition::LOS);
+    return m_losCondition == ChannelCondition::LOS;
 }
 
 bool
 ChannelCondition::IsNlos() const
 {
-    return (m_losCondition == ChannelCondition::NLOS);
+    return m_losCondition == ChannelCondition::NLOS;
 }
 
 bool
 ChannelCondition::IsNlosv() const
 {
-    return (m_losCondition == ChannelCondition::NLOSv);
+    return m_losCondition == ChannelCondition::NLOSv;
 }
 
 bool
 ChannelCondition::IsO2i() const
 {
-    return (m_o2iCondition == ChannelCondition::O2I);
+    return m_o2iCondition == ChannelCondition::O2I;
 }
 
 bool
 ChannelCondition::IsO2o() const
 {
-    return (m_o2iCondition == ChannelCondition::O2O);
+    return m_o2iCondition == ChannelCondition::O2O;
 }
 
 bool
 ChannelCondition::IsI2i() const
 {
-    return (m_o2iCondition == ChannelCondition::I2I);
+    return m_o2iCondition == ChannelCondition::I2I;
 }
 
 bool
 ChannelCondition::IsEqual(LosConditionValue losCondition, O2iConditionValue o2iCondition) const
 {
-    return (m_losCondition == losCondition && m_o2iCondition == o2iCondition);
+    return m_losCondition == losCondition && m_o2iCondition == o2iCondition;
 }
 
 std::ostream&
@@ -686,7 +686,7 @@
     // compute the 2D distance between a and b
     double distance2D = Calculate2dDistance(a->GetPosition(), b->GetPosition());
 
-    // NOTE: no idication is given about the UT height used to derive the
+    // NOTE: no indication is given about the UT height used to derive the
     // LOS probability
 
     // h_BS should be equal to 10 m. We check if at least one of the two
@@ -741,7 +741,7 @@
     // compute the 2D distance between a and b
     double distance2D = Calculate2dDistance(a->GetPosition(), b->GetPosition());
 
-    // NOTE: no idication is given about the UT height used to derive the
+    // NOTE: no indication is given about the UT height used to derive the
     // LOS probability
 
     // retrieve h_BS, it should be equal to 3 m
@@ -800,7 +800,7 @@
     // compute the 2D distance between a and b
     double distance2D = Calculate2dDistance(a->GetPosition(), b->GetPosition());
 
-    // NOTE: no idication is given about the UT height used to derive the
+    // NOTE: no indication is given about the UT height used to derive the
     // LOS probability
 
     // retrieve h_BS, it should be equal to 3 m
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.cc ns-3.41/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.cc
--- ns-3.40/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.cc	2024-02-09 14:44:08.457794000 -0800
@@ -48,22 +48,23 @@
                 DoubleValue(2160e6),
                 MakeDoubleAccessor(&ItuR1411NlosOverRooftopPropagationLossModel::SetFrequency),
                 MakeDoubleChecker<double>())
-            .AddAttribute(
-                "Environment",
-                "Environment Scenario",
-                EnumValue(UrbanEnvironment),
-                MakeEnumAccessor(&ItuR1411NlosOverRooftopPropagationLossModel::m_environment),
-                MakeEnumChecker(UrbanEnvironment,
-                                "Urban",
-                                SubUrbanEnvironment,
-                                "SubUrban",
-                                OpenAreasEnvironment,
-                                "OpenAreas"))
+            .AddAttribute("Environment",
+                          "Environment Scenario",
+                          EnumValue(UrbanEnvironment),
+                          MakeEnumAccessor<EnvironmentType>(
+                              &ItuR1411NlosOverRooftopPropagationLossModel::m_environment),
+                          MakeEnumChecker(UrbanEnvironment,
+                                          "Urban",
+                                          SubUrbanEnvironment,
+                                          "SubUrban",
+                                          OpenAreasEnvironment,
+                                          "OpenAreas"))
             .AddAttribute(
                 "CitySize",
                 "Dimension of the city",
                 EnumValue(LargeCity),
-                MakeEnumAccessor(&ItuR1411NlosOverRooftopPropagationLossModel::m_citySize),
+                MakeEnumAccessor<CitySize>(
+                    &ItuR1411NlosOverRooftopPropagationLossModel::m_citySize),
                 MakeEnumChecker(SmallCity, "Small", MediumCity, "Medium", LargeCity, "Large"))
             .AddAttribute(
                 "RooftopLevel",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.cc ns-3.41/src/propagation/model/okumura-hata-propagation-loss-model.cc
--- ns-3.40/src/propagation/model/okumura-hata-propagation-loss-model.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/propagation/model/okumura-hata-propagation-loss-model.cc	2024-02-09 14:44:08.457794000 -0800
@@ -48,21 +48,22 @@
                           DoubleValue(2160e6),
                           MakeDoubleAccessor(&OkumuraHataPropagationLossModel::m_frequency),
                           MakeDoubleChecker<double>())
-            .AddAttribute("Environment",
-                          "Environment Scenario",
-                          EnumValue(UrbanEnvironment),
-                          MakeEnumAccessor(&OkumuraHataPropagationLossModel::m_environment),
-                          MakeEnumChecker(UrbanEnvironment,
-                                          "Urban",
-                                          SubUrbanEnvironment,
-                                          "SubUrban",
-                                          OpenAreasEnvironment,
-                                          "OpenAreas"))
+            .AddAttribute(
+                "Environment",
+                "Environment Scenario",
+                EnumValue(UrbanEnvironment),
+                MakeEnumAccessor<EnvironmentType>(&OkumuraHataPropagationLossModel::m_environment),
+                MakeEnumChecker(UrbanEnvironment,
+                                "Urban",
+                                SubUrbanEnvironment,
+                                "SubUrban",
+                                OpenAreasEnvironment,
+                                "OpenAreas"))
             .AddAttribute(
                 "CitySize",
                 "Dimension of the city",
                 EnumValue(LargeCity),
-                MakeEnumAccessor(&OkumuraHataPropagationLossModel::m_citySize),
+                MakeEnumAccessor<CitySize>(&OkumuraHataPropagationLossModel::m_citySize),
                 MakeEnumChecker(SmallCity, "Small", MediumCity, "Medium", LargeCity, "Large"));
     return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/probabilistic-v2v-channel-condition-model.cc ns-3.41/src/propagation/model/probabilistic-v2v-channel-condition-model.cc
--- ns-3.40/src/propagation/model/probabilistic-v2v-channel-condition-model.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/propagation/model/probabilistic-v2v-channel-condition-model.cc	2024-02-09 14:44:08.457794000 -0800
@@ -38,18 +38,18 @@
             .SetParent<ThreeGppChannelConditionModel>()
             .SetGroupName("Propagation")
             .AddConstructor<ProbabilisticV2vUrbanChannelConditionModel>()
-            .AddAttribute(
-                "Density",
-                "Specifies the density of the vehicles in the scenario."
-                "It can be set to Low, Medium or High.",
-                EnumValue(VehicleDensity::LOW),
-                MakeEnumAccessor(&ProbabilisticV2vUrbanChannelConditionModel::m_densityUrban),
-                MakeEnumChecker(VehicleDensity::LOW,
-                                "Low",
-                                VehicleDensity::MEDIUM,
-                                "Medium",
-                                VehicleDensity::HIGH,
-                                "High"));
+            .AddAttribute("Density",
+                          "Specifies the density of the vehicles in the scenario."
+                          "It can be set to Low, Medium or High.",
+                          EnumValue(VehicleDensity::LOW),
+                          MakeEnumAccessor<VehicleDensity>(
+                              &ProbabilisticV2vUrbanChannelConditionModel::m_densityUrban),
+                          MakeEnumChecker(VehicleDensity::LOW,
+                                          "Low",
+                                          VehicleDensity::MEDIUM,
+                                          "Medium",
+                                          VehicleDensity::HIGH,
+                                          "High"));
     return tid;
 }
 
@@ -141,18 +141,18 @@
             .SetParent<ThreeGppChannelConditionModel>()
             .SetGroupName("Propagation")
             .AddConstructor<ProbabilisticV2vHighwayChannelConditionModel>()
-            .AddAttribute(
-                "Density",
-                "Specifies the density of the vehicles in the scenario."
-                "It can be set to Low, Medium or High.",
-                EnumValue(VehicleDensity::LOW),
-                MakeEnumAccessor(&ProbabilisticV2vHighwayChannelConditionModel::m_densityHighway),
-                MakeEnumChecker(VehicleDensity::LOW,
-                                "Low",
-                                VehicleDensity::MEDIUM,
-                                "Medium",
-                                VehicleDensity::HIGH,
-                                "High"));
+            .AddAttribute("Density",
+                          "Specifies the density of the vehicles in the scenario."
+                          "It can be set to Low, Medium or High.",
+                          EnumValue(VehicleDensity::LOW),
+                          MakeEnumAccessor<VehicleDensity>(
+                              &ProbabilisticV2vHighwayChannelConditionModel::m_densityHighway),
+                          MakeEnumChecker(VehicleDensity::LOW,
+                                          "Low",
+                                          VehicleDensity::MEDIUM,
+                                          "Medium",
+                                          VehicleDensity::HIGH,
+                                          "High"));
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/propagation-cache.h ns-3.41/src/propagation/model/propagation-cache.h
--- ns-3.40/src/propagation/model/propagation-cache.h	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/propagation/model/propagation-cache.h	2024-02-09 14:44:08.457794000 -0800
@@ -54,7 +54,7 @@
             return nullptr;
         }
         return it->second;
-    };
+    }
 
     /**
      * Add a model to the path
@@ -71,7 +71,7 @@
         PropagationPathIdentifier key = PropagationPathIdentifier(a, b, modelUid);
         NS_ASSERT(m_pathCache.find(key) == m_pathCache.end());
         m_pathCache.insert(std::make_pair(key, data));
-    };
+    }
 
     /**
      * Clean the cache
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/propagation/model/propagation-loss-model.h ns-3.41/src/propagation/model/propagation-loss-model.h
--- ns-3.40/src/propagation/model/propagation-loss-model.h	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/propagation/model/propagation-loss-model.h	2024-02-09 14:44:08.457794000 -0800
@@ -27,7 +27,7 @@
 #include "ns3/object.h"
 #include "ns3/random-variable-stream.h"
 
-#include <map>
+#include <unordered_map>
 
 namespace ns3
 {
@@ -742,9 +742,29 @@
     double m_default; //!< default loss
 
     /// Typedef: Mobility models pair
-    typedef std::pair<Ptr<MobilityModel>, Ptr<MobilityModel>> MobilityPair;
+    typedef std::pair<const Ptr<MobilityModel>, const Ptr<MobilityModel>> MobilityPair;
 
-    std::map<MobilityPair, double> m_loss; //!< Propagation loss between pair of nodes
+    /**
+     * \ingroup propagation
+     *
+     * \brief Hasher for a pair of mobility models.
+     */
+    class MobilityPairHasher
+    {
+      public:
+        /**
+         * \brief Get the hash for a MobilityPair.
+         * \param key MobilityPair reference to hash
+         * \return the MobilityPair hash
+         */
+        size_t operator()(const MobilityPair& key) const
+        {
+            return uint64_t(key.first.operator->()) ^ uint64_t(key.second.operator->());
+        }
+    };
+
+    std::unordered_map<MobilityPair, double, MobilityPairHasher>
+        m_loss; //!< Propagation loss between pair of nodes
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/CMakeLists.txt ns-3.41/src/sixlowpan/CMakeLists.txt
--- ns-3.40/src/sixlowpan/CMakeLists.txt	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/CMakeLists.txt	2024-02-09 14:44:08.457794000 -0800
@@ -15,8 +15,7 @@
     helper/sixlowpan-helper.h
     model/sixlowpan-header.h
     model/sixlowpan-net-device.h
-  LIBRARIES_TO_LINK
-    ${libinternet}
+  LIBRARIES_TO_LINK ${libinternet}
   TEST_SOURCES
     ${example_as_test_suite}
     test/mock-net-device.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc ns-3.41/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc
--- ns-3.40/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/examples/example-ping-lr-wpan-beacon.cc	2024-02-09 14:44:08.457794000 -0800
@@ -35,7 +35,7 @@
 {
     // In the case of transmissions with the Ack flag activated, the transaction is only
     // successful if the Ack was received.
-    if (params.m_status == LrWpanMcpsDataConfirmStatus::IEEE_802_15_4_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " | Node " << device->GetNode()->GetId()
                   << " | Transmission successfully sent\n";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/examples/example-sixlowpan.cc ns-3.41/src/sixlowpan/examples/example-sixlowpan.cc
--- ns-3.40/src/sixlowpan/examples/example-sixlowpan.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/examples/example-sixlowpan.cc	2024-02-09 14:44:08.457794000 -0800
@@ -88,7 +88,6 @@
     NetDeviceContainer d1 = csma.Install(net1);
 
     SixLowPanHelper sixlowpan;
-    sixlowpan.SetDeviceAttribute("ForceEtherType", BooleanValue(true));
     NetDeviceContainer six1 = sixlowpan.Install(d1);
 
     NS_LOG_INFO("Create networks and assign IPv6 Addresses.");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.41/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.40/src/sixlowpan/model/sixlowpan-net-device.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/model/sixlowpan-net-device.cc	2024-02-09 14:44:08.461794100 -0800
@@ -83,16 +83,6 @@
                           UintegerValue(0x0),
                           MakeUintegerAccessor(&SixLowPanNetDevice::m_compressionThreshold),
                           MakeUintegerChecker<uint32_t>())
-            .AddAttribute("ForceEtherType",
-                          "Force a specific EtherType in L2 frames.",
-                          BooleanValue(false),
-                          MakeBooleanAccessor(&SixLowPanNetDevice::m_forceEtherType),
-                          MakeBooleanChecker())
-            .AddAttribute("EtherType",
-                          "The specific EtherType to be used in L2 frames.",
-                          UintegerValue(0xFFFF),
-                          MakeUintegerAccessor(&SixLowPanNetDevice::m_etherType),
-                          MakeUintegerChecker<uint16_t>())
             .AddAttribute("UseMeshUnder",
                           "Use a mesh-under routing protocol.",
                           BooleanValue(false),
@@ -158,10 +148,13 @@
 
     NS_LOG_DEBUG("RegisterProtocolHandler for " << device->GetInstanceTypeId().GetName());
 
-    uint16_t protocolType = 0;
-    if (m_forceEtherType)
+    uint16_t protocolType = PROT_NUMBER;
+    if (device->GetInstanceTypeId().GetName() == "ns3::LrWpanNetDevice")
     {
-        protocolType = m_etherType;
+        // LrWpanNetDevice does not have a protocol number in the frame.
+        // Hence, we must register for any protocol, and assume that any
+        // packet is 6LoWPAN.
+        protocolType = 0;
     }
     m_node->RegisterProtocolHandler(MakeCallback(&SixLowPanNetDevice::ReceiveFromDevice, this),
                                     protocolType,
@@ -596,10 +589,7 @@
 
     bool useMesh = m_meshUnder;
 
-    if (m_forceEtherType)
-    {
-        protocolNumber = m_etherType;
-    }
+    protocolNumber = PROT_NUMBER;
 
     if (m_useIphc)
     {
@@ -2714,7 +2704,7 @@
 
     auto iter = --m_timeoutEventList.end();
 
-    return (iter);
+    return iter;
 }
 
 void
